import mock
import unittest2 as unittest


class TestCropImageIDControlPanelForm(unittest.TestCase):

    def createInstance(self):
        """Create CropImageIDControlPanelForm instance."""
        from inicie.cropimage.browser.template import CropImageIDControlPanelForm
        return CropImageIDControlPanelForm(mock.Mock(), mock.Mock())

    def test_instance(self):
        item = self.createInstance()
        from inicie.cropimage.browser.template import CropImageIDControlPanelForm
        self.assertTrue(isinstance(item, CropImageIDControlPanelForm))
        from plone.z3cform.crud.crud import CrudForm
        self.assertTrue(issubclass(CropImageIDControlPanelForm, CrudForm))

    # def test_update_schema(self):
    #     item = self.createInstance()
    #     from inicie.cropimage.bank import IBank
    #     self.assertTrue(item.update_schema is IBank)

    def test_label(self):
        item = self.createInstance()
        self.assertEqual(item.label, u'Crop Image ID')

    # @mock.patch('inicie.cropimage.browser.template.getUtility', banks)
    # def test_get_items(self):
    #     item = self.createInstance()
    #     items = item.get_items()
    #     names = [i[0] for i in items]
    #     self.assertEqual(
    #         names,
    #         [
    #             'AKTIATEST',
    #             'OSUUSTEST',
    #             'NORDEATEST',
    #             'HANDELSTEST',
    #             'SPANKKITEST',
    #             'SAMPOTEST',
    #             'TAPIOLATEST',
    #         ]
    #     )
    #     values = [
    #         (
    #             val[1].name,
    #             val[1].bank_code,
    #             val[1].version,
    #             val[1].provider,
    #             val[1].lang_code,
    #             val[1].id_type,
    #             val[1].key_version,
    #             val[1].hash_key,
    #             val[1].post_url,
    #         ) for val in items
    #     ]
    #     from inicie.cropimage.config import TEST_BANKS
    #     keys = [
    #         'name',
    #         'bank_code',
    #         'version',
    #         'provider',
    #         'lang_code',
    #         'id_type',
    #         'key_version',
    #         'hash_key',
    #         'post_url',
    #     ]
    #     bank_values = [
    #         tuple(
    #             [
    #                 bank[key] for key in keys
    #             ]
    #         ) for bank in TEST_BANKS[:]
    #     ]
    #     self.assertEqual(values, bank_values)

    # @mock.patch('inicie.cropimage.browser.template.crud.CrudForm.update')
    # def test_update(self, crud_form_update):
    #     item = self.createInstance()
    #     form = mock.Mock()
    #     form.widgets = {
    #         'name': mock.Mock(),
    #         'version': mock.Mock(),
    #         'provider': mock.Mock(),
    #         'id_type': mock.Mock(),
    #         'key_version': mock.Mock(),
    #         'hash_key': mock.Mock(),
    #         'post_url': mock.Mock(),
    #     }
    #     edit_forms = mock.Mock()
    #     add_form = mock.Mock()
    #     add_form.widgets = {
    #         'name': mock.Mock(),
    #         'version': mock.Mock(),
    #         'provider': mock.Mock(),
    #         'id_type': mock.Mock(),
    #         'key_version': mock.Mock(),
    #         'hash_key': mock.Mock(),
    #         'post_url': mock.Mock(),
    #     }
    #     item.subforms = [edit_forms, add_form]
    #     # form = mock.Mock()
    #     edit_forms.subforms = [form]
    #     item.update()
    #     form = item.subforms[0].subforms[0]
    #     self.assertEqual(form.widgets['name'].size, 10)
    #     self.assertEqual(form.widgets['version'].size, 4)
    #     self.assertEqual(form.widgets['provider'].size, 15)
    #     self.assertEqual(form.widgets['id_type'].size, 2)
    #     self.assertEqual(form.widgets['key_version'].size, 4)
    #     self.assertEqual(form.widgets['hash_key'].size, 20)
    #     self.assertEqual(form.widgets['post_url'].size, 40)
    #     self.assertEqual(add_form.widgets['name'].size, 10)
    #     self.assertEqual(add_form.widgets['version'].size, 4)
    #     self.assertEqual(add_form.widgets['provider'].size, 15)
    #     self.assertEqual(add_form.widgets['id_type'].size, 2)
    #     self.assertEqual(add_form.widgets['key_version'].size, 4)
    #     self.assertEqual(add_form.widgets['hash_key'].size, 20)
    #     self.assertEqual(add_form.widgets['post_url'].size, 40)

    # @mock.patch('inicie.cropimage.browser.template.getUtility')
    # def test_add(self, getUtility):
    #     banks = {'inicie.cropimage.banks': []}
    #     getUtility.return_value = banks
    #     item = self.createInstance()
    #     data = 'data'
    #     item.add(data)
    #     self.assertEqual(banks['inicie.cropimage.banks'], ['data'])

    # @mock.patch('inicie.cropimage.browser.template.getUtility')
    # def test_remove(self, getUtility):
    #     banks = {'inicie.cropimage.banks': [{'name': 'some_id'}]}
    #     getUtility.return_value = banks
    #     item = self.createInstance()
    #     ## id does not exists in inicie.cropimage.banks registry.
    #     item.remove(('id', mock.Mock()))
    #     self.assertEqual(banks['inicie.cropimage.banks'], [{'name': 'some_id'}])
    #     ## id does exists in inicie.cropimage.banks registry.
    #     item.remove(('some_id', mock.Mock()))
    #     self.assertEqual(banks['inicie.cropimage.banks'], [])

    def test_CropImageIDControlPanelView(self):
        from inicie.cropimage.browser.template import CropImageIDControlPanelView
        self.assertEqual(
            CropImageIDControlPanelView.__name__,
            'MyFormWrapper'
        )
        self.assertEqual(
            CropImageIDControlPanelView.form.__name__,
            'CropImageIDControlPanelForm'
        )
        filename = CropImageIDControlPanelView.index.filename.split('/')[-1]
        self.assertEqual(
            filename,
            'controlpanel.pt'
        )
