from setuptools import find_packages
from setuptools import setup

import os


def read(*rnames):
    return open(os.path.join(os.path.dirname(__file__), *rnames)).read()


version = read('inicie', 'cropimage', 'version.txt').strip()

long_description = (
    read('inicie', 'cropimage', 'docs', 'README.rst'))

setup(name='inicie.cropimage',
      version=version,
      description="Store cropped image dimension for farther usage.",
      long_description=long_description,
      # Get more strings from
      # http://pypi.python.org/pypi?:action=list_classifiers
      classifiers=[
        "Framework :: Plone",
        "Programming Language :: Python",
        ],
      keywords='',
      author='Taito Horiuchi ',
      author_email='taito.horiuchi@gmail.com',
      url='',
      license='BSD',
      packages=find_packages(exclude=['ez_setup']),
      namespace_packages=['inicie'],
      include_package_data=True,
      zip_safe=False,
      install_requires=[
          'hexagonit.testing',
          'manuel',
          'plone.app.registry',
          'plone.app.testing',
          'plone.browserlayer',
          'setuptools',
          'unittest2',
          'zope.i18nmessageid',
      ],
      entry_points="""
      # -*- Entry points: -*-

      [z3c.autoinclude.plugin]
      target = plone
      """,
      )
